<?php
$oID = $insert_id;

$fraudlabspro_license = $db->Execute("select configuration_value FROM " . TABLE_CONFIGURATION . " WHERE configuration_key = 'FRAUDLABSPRO_LICENSE'");

$check_status_query = "select customers_name, billing_street_address, billing_city, billing_state, billing_postcode, billing_country, customers_telephone, customers_email_address, cc_number, delivery_street_address, delivery_city, delivery_state, delivery_postcode, delivery_country, ip_address, order_total, currency from " . TABLE_ORDERS . " where orders_id = '" . (int)$oID . "'";
$check_status = $db->Execute($check_status_query);

$check_quantity_query = "SELECT SUM(products_quantity) AS quantity FROM " . TABLE_ORDERS_PRODUCTS . " where orders_id = '" . (int)$oID . "'";
$check_quantity = $db->Execute($check_quantity_query);

$check_customer_password_query = "select customers_password from " . TABLE_CUSTOMERS . " where customers_email_address = '" . $check_status->fields['customers_email_address'] . "'";
$check_customer_password = $db->Execute($check_customer_password_query);

if (strlen($check_status->fields['billing_country']) <= 2) {
	$check_country->fields = array (
		"countries_iso_code_2" => $check_status->fields['billing_country']); }
else {
$check_country_query = "select countries_iso_code_2 from " . TABLE_COUNTRIES . " where countries_name = '" . $check_status->fields['billing_country'] . "'";
$check_country = $db->Execute($check_country_query); }

if (strlen($check_status->fields['delivery_country']) <= 2) {
	$check_delivery_country->fields = array (
		"countries_iso_code_2" => $check_status->fields['delivery_country']); }
else {
$check_delivery_country_query = "select countries_iso_code_2 from " . TABLE_COUNTRIES . " where countries_name = '" . $check_status->fields['delivery_country'] . "'";
$check_delivery_country = $db->Execute($check_delivery_country_query); }

if (strlen($check_status->fields['billing_state']) <= 2) {
	$check_state->fields = array (
		"zone_code" => $check_status->fields['billing_state']); }
else {
$check_state_query = "select zone_code from " . TABLE_ZONES . " where zone_name = '" . $check_status->fields['billing_state'] . "'";
$check_state = $db->Execute($check_state_query); }

if (strlen($check_status->fields['delivery_state']) <= 2) {
	$check_delivery_state->fields = array (
		"zone_code" => $check_status->fields['delivery_state']); }
else {
$check_delivery_state_query = "select zone_code from " . TABLE_ZONES . " where zone_name = '" . $check_status->fields['delivery_state'] . "'";
$check_delivery_state = $db->Execute($check_delivery_state_query); }

$str = $check_status->fields['customers_email_address'];
list ($addy, $domain) = split ('[@]', $str);

$phstr = preg_replace( '/[^0123456789]/', '', $check_status->fields['customers_telephone']);
$phone = substr($phstr, 0, 6);

$cc_full = $check_status->fields['cc_number'];
$cc = substr($cc_full, 0, 6);
// Depending on module, won't return anything or asterisks.
// Custom coding needed on the actual model since the credit card is NOT stored by default.

// Payment code.
// Added in a few known payment modules, will come back to this later when I can scan more
// files from the ZenCart Plugin DB.
$payment_code = $check_status->fields['payment_module_code'];
switch($payment_code) {
	case "moneyorder":
		$h["payment_mode"] = "moneyorder";
	break;
	case "coinbasepp":
		$h["payment_mode"] = "bitcoin";
	break;
	case "paypal":
	case "paypaldp":
	case "paypalwpp":
		$h["payment_mode"] = "paypal";
	break;
	case "cod":
		$h["payment_mode"] = "cod";
	break;
	case "authorizenet":
	case "qbms":
	case "authorizenet_aim":
	case "linkpoint_api":
		$h["payment_mode"] = "creditcard";
	break;
	default:
		$h["payment_mode"] = "others";
	break;
}

$ip = $_SERVER['REMOTE_ADDR'];

if(isset($_SERVER['HTTP_CF_CONNECTING_IP']) && filter_var($_SERVER['HTTP_CF_CONNECTING_IP'], FILTER_VALIDATE_IP)){
	$ip = $_SERVER['HTTP_CF_CONNECTING_IP'];
}

if(isset($_SERVER['HTTP_X_FORWARDED_FOR']) && filter_var($_SERVER['HTTP_X_FORWARDED_FOR'], FILTER_VALIDATE_IP)){
	$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
}

$h["key"] = $fraudlabspro_license->fields['configuration_value'];

// Required fields
$h["format"] = "json";
$h["ip"] = $ip;      													// set the client ip address
$h["first_name"] = $check_status->fields['customers_name']; 			// set the client name
$h["last_name"] = " "; 	
$h["bill_city"] = $check_status->fields['billing_city'];             	// set the billing city
$h["bill_state"] = $check_state->fields['zone_code'];					// set the billing state
$h["bill_zip_code"] = $check_status->fields['billing_postcode'];		// set the billing zip code
$h["bill_country"] = $check_country->fields['countries_iso_code_2'];	// set the billing country
$h["user_phone"] = $check_status->fields['customers_telephone'];		// Area-code and local prefix of customer phone number
$h["ship_addr"] = $check_status->fields['delivery_street_address'];		// Shipping Address
$h["ship_city"] = $check_status->fields['delivery_city'];				// the City to Ship to
$h["ship_state"] = $check_delivery_state->fields['zone_code'];			// the Region to Ship to
$h["ship_zip_code"] = $check_status->fields['delivery_postcode'];		// the Postal Code to Ship to
$h["ship_country"] = $check_delivery_country->fields['countries_iso_code_2'];	// the country to Ship to

// Recommended fields
$h["email"] = $str;
$h["email_domain"] = $domain;						// Email domain
$h["bin_no"] = $cc;									// bank identification number
$h["email_hash"] = hashIt($check_status->fields['customers_email_address']);
$h["username_hash"] = hashIt($check_status->fields['customers_email_address']);
$h["password_hash"] = hashIt($check_customer_password->fields['customers_password']);

// Optional fields
//$h["bin_bank_name"] = $check_status->fields['cc_bin_name'];			// bank name
//$h["bin_bank_phone"] = $check_status->fields['cc_bin_phone'];			// bank customer service phone number on back of credit card

$h["user_order_id"] = $oID;							// Transaction ID

$h["department"] = STORE_NAME; // Store name
$h["amount"] = $check_status->fields['order_total'];
$h["quantity"] = $check_quantity->fields['quantity'];
$h["currency"] = $check_status->fields['currency'];
$h["source"] = 'zencart';
$h["source_version"] = '1.0.4';

$queries = '';
foreach($h as $key=>$value){
	$queries .= $key . '=' . urlencode($value) . '&';
}

$url = 'https://api.fraudlabspro.com/v1/order/screen?' . rtrim($queries, '&');
// Trying to connect FraudLabs Pro Web Service for 3 times
for($i=0; $i<3; $i++){

 if (!$response = connect_curl($url)) {
	$response = @file_get_contents($url);
    // For security purposes, many hosts disable file_get_contents by default.
	// So it should be used as a last resort if cURL can't connect.
 }
	if(is_null($json = json_decode($response)) === FALSE){
		$sql_data_array = array(
			'api_key' => $h["key"],
			'is_country_match' => $json->is_country_match,
			'is_high_risk_country' => $json->is_high_risk_country,
			'distance_in_km' => $json->distance_in_km,
			'distance_in_mile' => $json->distance_in_mile,
			'ip_address' => $h["ip"],
			'ip_country' => $json->ip_country,
			'ip_continent' => $json->ip_continent,
			'ip_region' => $json->ip_region,
			'ip_city' => $json->ip_city,
			'ip_latitude' => $json->ip_latitude,
			'ip_longitude' => $json->ip_longitude,
			'ip_timezone' => $json->ip_timezone,
			'ip_elevation' => $json->ip_elevation,
			'ip_domain' => $json->ip_domain,
			'ip_mobile_mnc' => $json->ip_mobile_mnc,
			'ip_mobile_mcc' => $json->ip_mobile_mcc,
			'ip_mobile_brand' => $json->ip_mobile_brand,
			'ip_netspeed' => $json->ip_netspeed,
			'ip_isp_name' => $json->ip_isp_name,
			'ip_usage_type' => $json->ip_usage_type,
			'is_free_email' => $json->is_free_email,
			'is_new_domain_name' => $json->is_new_domain_name,
			'is_proxy_ip_address' => $json->is_proxy_ip_address,
			'is_bin_found' => $json->is_bin_found,
			'is_bin_country_match' => $json->is_bin_country_match,
			'is_bin_name_match' => $json->is_bin_name_match,
			'is_bin_phone_match' => $json->is_bin_phone_match,
			'is_bin_prepaid' => $json->is_bin_prepaid,
			'is_address_ship_forward' => $json->is_address_ship_forward,
			'is_bill_ship_city_match' => $json->is_bill_ship_city_match,
			'is_bill_ship_state_match' => $json->is_bill_ship_state_match,
			'is_bill_ship_country_match' => $json->is_bill_ship_country_match,
			'is_bill_ship_postal_match' => $json->is_bill_ship_postal_match,
			'is_ip_blacklist' => $json->is_ip_blacklist,
			'is_email_blacklist' => $json->is_email_blacklist,
			'is_credit_card_blacklist' => $json->is_credit_card_blacklist,
			'is_device_blacklist' => $json->is_device_blacklist,
			'is_user_blacklist' => $json->is_user_blacklist,
			'flp_score' => $json->fraudlabspro_score,
			'flp_distribution' => $json->fraudlabspro_distribution,
			'flp_status' => $json->fraudlabspro_status,
			'flp_id' => $json->fraudlabspro_id,
			'flp_error_code' => $json->fraudlabspro_error_code,
			'flp_message' => $json->fraudlabspro_message,
			'flp_credits' => $json->fraudlabspro_credits,
			'order_id' => $insert_id
		);

		zen_db_perform(TABLE_ORDERS_FRAUDLABSPRO, $sql_data_array);
		break; // Get out from the FOR loop once attempt succeed
	}
}

function hashIt($s, $prefix='fraudlabspro_'){
	$hash = $prefix . $s;
	for($i=0; $i<65536; $i++) $hash = sha1($prefix . $hash);

	return $hash;
}

function connect_curl ($url) {
	if (function_exists('curl_init')) {

	$ch = curl_init();

	// Now set some options (most are optional)
	curl_setopt($ch, CURLOPT_URL, $url);

	// Set a referer
	curl_setopt($ch, CURLOPT_REFERER, HTTP_SERVER);

	// Include header in result? (0 = yes, 1 = no)
	curl_setopt($ch, CURLOPT_HEADER, 0);

	// Should cURL return or print out the data? (true = return, false = print)
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

	// Timeout in seconds
	curl_setopt($ch, CURLOPT_TIMEOUT, 120);

	// Download the given URL, and return output
	$response = curl_exec($ch);

	// Close the cURL resource, and free system resources
	curl_close($ch);

	return $response;
	} else {
		return NULL;
	}
}


?>